# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_util.ipynb.

# %% auto 0
__all__ = ['todunder', 'getcard', 'iscard', 'is1char', 'dropext']

# %% ../nbs/10_util.ipynb 4
from typing import Optional
import os, pathlib

# %% ../nbs/10_util.ipynb 5
from .nstr import DOT, NIL, SPACE, SUNDER, DUNDER
from .filt import prepart
from .chck import isdunder

# %% ../nbs/10_util.ipynb 6
def todunder(s: str) -> str:
    return f'__{s}__' if not isdunder(s) else s

# %% ../nbs/10_util.ipynb 7
def getcard(s: str) -> int:
    '''Returns the cardinality of the set of characters for the string.'''
    return len(set(s))

def iscard(s: str, n: int = 1) -> bool:
    '''Checks if a string is composed of a set of `n` characters.'''
    return getcard(s) == n

def is1char(s: str) -> bool:
    '''Checks if a string is composed of a single unique character.'''
    return iscard(s, 1)

# %% ../nbs/10_util.ipynb 8
def dropext(file: str, ext: Optional[str] = None) -> str:  
    file = os.fspath(file) if isinstance(file, pathlib.Path) else file
    file = os.path.basename(file)   
    file = prepart(file, DOT) if ext is None else file.replace(ext, NIL)
    return os.path.join(os.path.dirname(file), file)
